package com.sibatel.solarapp.adapter

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.sibatel.solarapp.data.model.solar.pengambilansolar.PengambilanSolar
import com.sibatel.solarapp.databinding.FragmentPengambilanSolarBinding
import com.sibatel.solarapp.databinding.ListMentoringSolarBinding
import com.sibatel.solarapp.databinding.ListPenggunaanSolarBinding

class PengambilanSolarAdapter(var listPengambilanSolar : ArrayList<PengambilanSolar>?) : RecyclerView.Adapter<PengambilanSolarAdapter.PengambilanSolarViewHolder>() {

    inner class PengambilanSolarViewHolder(private val binding: ListMentoringSolarBinding) : RecyclerView.ViewHolder(binding.root){
        val tanggal = binding.tanggal
        val jlh_pendonor_sdh = binding.jlhPendonorSdh
        val jlh_solar_diambil = binding.jlhSolarDiambil
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): PengambilanSolarViewHolder {
        val view = ListMentoringSolarBinding.inflate(LayoutInflater.from(parent.context), parent, false)
        return PengambilanSolarViewHolder(view)
    }

    override fun onBindViewHolder(holder: PengambilanSolarViewHolder, position: Int) {
        holder.tanggal.text = listPengambilanSolar?.get(position)?.tanggal
        holder.jlh_pendonor_sdh.text = "Jumlah Solar terakhir di tangki pendonor: "+listPengambilanSolar?.get(position)?.jlhPendonorSdh+"L"
        holder.jlh_solar_diambil.text = "+"+listPengambilanSolar?.get(position)?.jlhSolarDiambil+" Liter"
    }

    override fun getItemCount(): Int {
        return listPengambilanSolar?.size ?:0
    }

}