package com.sibatel.solarapp.adapter

import android.graphics.Color
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.RecyclerView
import com.sibatel.solarapp.R
import com.sibatel.solarapp.data.model.solar.penggunaansolar.PenggunaanSolar
import com.sibatel.solarapp.databinding.ListPenggunaanSolarBinding
import java.text.SimpleDateFormat

class PenggunaanSolarAdapter(private val listPenggunaanSolar : ArrayList<PenggunaanSolar>?):RecyclerView.Adapter<PenggunaanSolarAdapter.PenggunaanSolarViewHolder>(){

    inner class PenggunaanSolarViewHolder(private val binding: ListPenggunaanSolarBinding) : RecyclerView.ViewHolder(binding.root){
        val tujuanSite = binding.tujuanSite
        val tanggal = binding.tanggal
        val hmAkhir = binding.hmAkhir
        val status = binding.status
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): PenggunaanSolarViewHolder {
        val view = ListPenggunaanSolarBinding.inflate(LayoutInflater.from(parent.context), parent, false)
        return PenggunaanSolarViewHolder(view)
    }

    override fun onBindViewHolder(holder: PenggunaanSolarViewHolder, position: Int) {
        holder.hmAkhir.text = listPenggunaanSolar?.get(position)?.hmAkhir
        holder.tanggal.text = listPenggunaanSolar?.get(position)?.tanggal
        holder.tujuanSite.text = "Tujuan : "+listPenggunaanSolar?.get(position)?.tujuanSite
        if (listPenggunaanSolar?.get(position)?.status.equals("1")){
            holder.status.text = "Proses"
        }else if(listPenggunaanSolar?.get(position)?.status.equals("2")){
            holder.status.text = "Selesai"
            holder.status.setTextColor(Color.GREEN)
        }else if(listPenggunaanSolar?.get(position)?.status.equals("3")){
            holder.status.text = "Batal"
            holder.status.setTextColor(Color.RED)
        }
    }

    override fun getItemCount(): Int {
        return listPenggunaanSolar?.size ?: 0
    }
}