package com.sibatel.solarapp.ui.maintenance

import android.app.DatePickerDialog
import android.content.Intent
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import android.view.View
import android.widget.AdapterView
import android.widget.ArrayAdapter
import android.widget.Spinner
import android.widget.Toast
import com.sibatel.solarapp.R
import com.sibatel.solarapp.data.model.tower.Maintenance
import com.sibatel.solarapp.data.model.tower.MaintenanceResponse
import com.sibatel.solarapp.data.model.tower.TowerResponse
import com.sibatel.solarapp.databinding.ActivityMaintenanceBinding
import com.sibatel.solarapp.databinding.ActivityMaintenanceMenuBinding
import com.sibatel.solarapp.network.ApiServices
import com.sibatel.solarapp.network.RetrofitClient
import com.sibatel.solarapp.utils.SharedPref
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import java.util.*
import kotlin.collections.ArrayList

class MaintenanceMenu : AppCompatActivity() {
    private lateinit var site: Spinner
    private lateinit var binding : ActivityMaintenanceMenuBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_maintenance_menu)

        binding = ActivityMaintenanceMenuBinding.inflate(layoutInflater)
        setContentView(binding.root)

        var tanggal = ""
        var siteMain = ""

        val sharedPref = SharedPref(this)
        var allTower = ArrayList<String>()
        allTower.add("Pilih Site")

        binding.user.text = sharedPref.getRole1()+"-"+sharedPref.getNama1()

        binding.dateSolarTaken.setOnClickListener {
            val cldr: Calendar = Calendar.getInstance()
            val day: Int = cldr.get(Calendar.DAY_OF_MONTH)
            val month: Int = cldr.get(Calendar.MONTH)
            val year: Int = cldr.get(Calendar.YEAR)
            var bulan = ""
            var hari = ""

            val picker = DatePickerDialog(
                this,
                { view, year, monthOfYear, dayOfMonth ->
                    if(monthOfYear + 1<10){
                        bulan = "0"+(monthOfYear + 1)
                    }else{
                        bulan = (monthOfYear + 1).toString()
                    }

                    if(dayOfMonth<10){
                        hari = "0"+dayOfMonth
                    }else{
                        hari = dayOfMonth.toString()
                    }
                    binding.dateSolarTaken.setText(
                        year.toString() + "-" + bulan + "-" + hari
                    )
                    tanggal =  binding.dateSolarTaken.text.toString()
                },
                year,
                month,
                day
            )
            picker.show()
        }

        RetrofitClient.apiInstance.getAllTower()
            .enqueue(object : Callback<TowerResponse>{
                override fun onResponse(
                    call: Call<TowerResponse>,
                    response: Response<TowerResponse>
                ) {
                    if (response.isSuccessful){
                        response.body()?.result?.forEach {
                            it?.namaTower?.let { it1 -> allTower.add(it1) }
                        }
                    }
                }

                override fun onFailure(call: Call<TowerResponse>, t: Throwable) {

                }

            })

        site = binding.site

        val adapter = ArrayAdapter<String>(this, android.R.layout.simple_spinner_dropdown_item, allTower)
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item)
        site.adapter = adapter

        site.onItemSelectedListener = object : AdapterView.OnItemSelectedListener{
            override fun onItemSelected(p0: AdapterView<*>?, p1: View?, p2: Int, p3: Long) {
                    if (p2 == 0 ){
                        siteMain = ""
                    }else{
                        val number = p0?.getItemAtPosition(p2).toString()
                        siteMain = number
                    }
            }

            override fun onNothingSelected(p0: AdapterView<*>?) {

            }

        }
        val id = sharedPref.getId().toString()

        binding.btnSimpan.setOnClickListener{
            binding.btnSimpan.startAnimation()
            tambahProses(id , tanggal, siteMain)
        }
    }

    fun tambahProses(id:String, tanggal: String, tujuan_site: String){
        RetrofitClient.apiInstance.tambahMaintenance(id, tanggal, tujuan_site)
            .enqueue(object : Callback<MaintenanceResponse>{
                override fun onResponse(
                    call: Call<MaintenanceResponse>,
                    response: Response<MaintenanceResponse>
                ) {
                        if (response.isSuccessful){
                            val intent = Intent(this@MaintenanceMenu, MaintenanceActivity::class.java)
                            startActivity(intent)
                            Toast.makeText(getApplicationContext(), "Sukses menambah data", Toast.LENGTH_LONG).show()
                            finish()
                        }else{
                            Toast.makeText(getApplicationContext(), response.message() ,
                                Toast.LENGTH_LONG).show()
                        }
                        binding.btnSimpan.revertAnimation()
                    }

                    override fun onFailure(call: Call<MaintenanceResponse>, t: Throwable) {
                        t.message?.let { Log.d("error Server", it)
                            binding.btnSimpan.revertAnimation()
                        }
                    }
                })
            }
}