package com.sibatel.solarapp.ui.mentoring.solar.pengambilan

import android.content.Intent
import android.os.Bundle
import androidx.fragment.app.Fragment
import android.view.LayoutInflater
import android.view.MenuItem
import android.view.View
import android.view.ViewGroup
import android.widget.Toast
import androidx.lifecycle.Observer
import androidx.lifecycle.ViewModelProvider
import com.google.android.material.floatingactionbutton.FloatingActionButton
import com.google.android.material.snackbar.Snackbar
import com.sibatel.solarapp.R
import com.sibatel.solarapp.adapter.PengambilanSolarAdapter
import com.sibatel.solarapp.data.model.solar.pengambilansolar.PengambilanSolar
import com.sibatel.solarapp.data.viewmodel.MobilViewModel
import com.sibatel.solarapp.data.viewmodel.PengambilanSolarViewModel
import com.sibatel.solarapp.databinding.FragmentPengambilanSolarBinding
import com.sibatel.solarapp.ui.LoginActivity
import com.sibatel.solarapp.ui.user.Profil
import com.sibatel.solarapp.utils.SharedPref
import com.sibatel.solarapp.utils.ViewModelFactory

class PengambilanSolarFragment : Fragment() {
    private lateinit var fragmentBinding: FragmentPengambilanSolarBinding
    private lateinit var sharedPref : SharedPref

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        fragmentBinding = FragmentPengambilanSolarBinding.inflate(inflater, container, false)
        return fragmentBinding.root
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        if (activity!=null){

            val fab: FloatingActionButton = fragmentBinding.fab
            sharedPref = context?.let { SharedPref(it) }!!

            fab.setOnClickListener {
                val intent = Intent(context, MenuPengambilanSolar::class.java)
                startActivity(intent)
                requireActivity().finish()
            }

            val factory = ViewModelFactory.getInstance()
            val viewModelCatalog = ViewModelProvider(
                this, factory
            )[PengambilanSolarViewModel::class.java]

            showLoading(true)

            viewModelCatalog.getPengambilanSolar(sharedPref.getId()).observe(viewLifecycleOwner, Observer {
                if (it.isEmpty()){
                    Toast.makeText(context, "Data Kosong", Toast.LENGTH_LONG).show()
                }else{
                    showDataPengambilanSolar(it)
                }

                showLoading(false)
            })
        }

    }
    private fun showDataPengambilanSolar(listPengambilanSolar :  ArrayList<PengambilanSolar>?){
        fragmentBinding.rvMentoringPengambilan.adapter = PengambilanSolarAdapter(listPengambilanSolar)
    }

    private fun showLoading(state: Boolean) {
        if (state)
            fragmentBinding.progress.visibility = View.VISIBLE
        else
            fragmentBinding.progress.visibility = View.GONE
    }

}