package com.sibatel.solarapp.ui.mentoring.solar.pengambilan

import android.app.AlertDialog
import android.content.DialogInterface
import android.content.Intent
import android.database.Cursor
import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.os.Bundle
import android.os.Environment
import android.provider.MediaStore
import android.text.Editable
import android.text.TextWatcher
import android.util.Base64
import android.util.Log
import android.widget.Spinner
import android.widget.Toast
import androidx.annotation.NonNull
import androidx.appcompat.app.AppCompatActivity
import androidx.core.content.FileProvider
import com.sibatel.solarapp.data.model.solar.pengambilansolar.PengambilanSolarResponse
import com.sibatel.solarapp.databinding.ActivityPengambilanSolarLjtnKoorBinding
import com.sibatel.solarapp.network.RetrofitClient
import com.sibatel.solarapp.ui.mentoring.MentoringSolar
import com.sibatel.solarapp.utils.SharedPref
import okhttp3.MediaType
import okhttp3.MultipartBody
import okhttp3.RequestBody
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import java.io.*
import java.util.HashMap

class PengambilanSolarLjtn: AppCompatActivity()  {
    private lateinit var binding : ActivityPengambilanSolarLjtnKoorBinding
    private lateinit var site: Spinner
    private lateinit var sharedPref: SharedPref
    private lateinit var bitmap1 : Bitmap
    private lateinit var bitmap2 : Bitmap
    private var Document_img1: String = ""
    var img1 =""
    var img2 =""
    private var cekUp: Int = 0

    override fun onCreate(savedInstanceState: Bundle?){
        super.onCreate(savedInstanceState)
        binding = ActivityPengambilanSolarLjtnKoorBinding.inflate(layoutInflater)
        supportActionBar?.elevation = 0f
        supportActionBar?.setDisplayHomeAsUpEnabled(true)
        setContentView(binding.root)
        supportActionBar?.title = "Pengambilan Solar Lanjutan"
        supportActionBar?.setDisplayShowHomeEnabled(true)
        supportActionBar?.setDisplayHomeAsUpEnabled(true)

        sharedPref = SharedPref(this)

        binding.user.setText(sharedPref.getRole1())

        var jlhSolarDiambil = 0
        var slrDimobilStlh = ""
        var id = ""

        RetrofitClient.apiInstance.cekPengambilanSolar(sharedPref.getId())
            .enqueue(object : Callback<PengambilanSolarResponse> {
                override fun onResponse(
                    call: Call<PengambilanSolarResponse>,
                    response: Response<PengambilanSolarResponse>
                ) {
                    if (response.isSuccessful){
                        response.body()?.result?.forEach {
                            id = it?.id.toString()
                            jlhSolarDiambil = String.format("%.0f", it?.jlhSolarDiambil.toString().toDouble()).toInt()
                            binding.tanggal.text = "Tanggal : "+it?.tanggal
                            binding.dariSite.text = "Dari Site :"+it?.dariSite
                            binding.tujuanSite.text = "Tujuan Site/Tower :"+it?.tujuanSite
                            binding.jumlahTangkiSblmDiambil.text = "Jumlah Solar di Tangki Pendonor  sebelum diambil : "+it?.jlhPendonorSblm +"L"
                            binding.jmlhSolarDiambil.text = "Jumlah solar yang diambil : "+it?.jlhSolarDiambil+" L"
                            binding.jumlahSolarDitangkiPendonorStlh.text = "Jumlah Solar di Tangki Pendonor  setelah diambil : "+it?.jlhPendonorSdh+"L"
                        }
                    }else{
                        Toast.makeText(getApplicationContext(), response.message() ,
                            Toast.LENGTH_LONG).show()
                    }
                }

                override fun onFailure(call: Call<PengambilanSolarResponse>, t: Throwable) {
                    t.message?.let { Log.d("error Server", it) }
                }

            })

        binding.btnBbmMobilSebelum.setOnClickListener{
            cekUp = 1
            selectImage()
        }

        binding.btnBbmMobilSetelah.setOnClickListener{
            cekUp = 2
            selectImage()
        }

        binding.bbmDimobilSebelum.addTextChangedListener(object : TextWatcher{
            override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {

            }

            override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
                if (binding.bbmDimobilSebelum.text.isNotEmpty()){
                    var hsl = jlhSolarDiambil + p0.toString().toInt()
                    binding.bbmDimobilSesudah.setText(hsl.toString())
                    slrDimobilStlh = hsl.toString()
                }
            }

            override fun afterTextChanged(p0: Editable?) {

            }

        })

        val jlhSlrGsSblm = binding.bbmDimobilSebelum.text

        binding.btnSelesai.setOnClickListener{
            binding.btnSelesai.startAnimation()
            addData(id ,jlhSlrGsSblm.toString(), slrDimobilStlh)
        }
    }

    private fun selectImage() {
        val options = arrayOf<CharSequence>("Take Photo", "Choose from Gallery", "Cancel")
        val builder = AlertDialog.Builder(this)
        builder.setTitle("Add Photo!")
        builder.setItems(options, DialogInterface.OnClickListener { dialog, item ->
            if (options[item] == "Take Photo") {
                val intent = Intent(MediaStore.ACTION_IMAGE_CAPTURE)
                val f = File(Environment.getExternalStorageDirectory(), "temp.jpg")
                intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
                val photoURI =  FileProvider.getUriForFile(this, this.getApplicationContext().getPackageName() + ".provider", f)
                intent.putExtra(MediaStore.EXTRA_OUTPUT, photoURI)
                startActivityForResult(intent, 1)
            } else if (options[item] == "Choose from Gallery") {
                val intent =
                    Intent(Intent.ACTION_PICK, MediaStore.Images.Media.EXTERNAL_CONTENT_URI)
                startActivityForResult(intent, 2)
            } else if (options[item] == "Cancel") {
                dialog.dismiss()
            }
        })
        builder.show()
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (resultCode == RESULT_OK){
            if (requestCode == 1){
                var f = File(Environment.getExternalStorageDirectory().toString())
                for (temp in f.listFiles()) {
                    if (temp.name == "temp.jpg") {
                        f = temp
                        break
                    }
                }
                try {
                    val bitmapOptions = BitmapFactory.Options()
                    if (cekUp == 1){
                        bitmap1 = BitmapFactory.decodeFile(f.absolutePath, bitmapOptions)
                        bitmap1 = getResizedBitmap(bitmap1, 400)
                        binding.imgBbmMobilSebelum.setImageBitmap(bitmap1)
                        BitMapToString(bitmap1)
                    }else if (cekUp == 2){
                        bitmap2 = BitmapFactory.decodeFile(f.absolutePath, bitmapOptions)
                        bitmap2 = getResizedBitmap(bitmap2, 400)
                        binding.imgBbmMobilSetelah.setImageBitmap(bitmap2)
                        BitMapToString(bitmap2)
                    }


                    val path = (Environment
                        .getExternalStorageDirectory()
                        .toString() + File.separator
                            + "Phoenix" + File.separator + "default")
                    f.delete()
                    var outFile: OutputStream? = null
                    val file = File(path, System.currentTimeMillis().toString() + ".jpg")
                    if (cekUp==1){
                        binding.btnBbmMobilSebelum.text = file.name.toString().toEditable()
                        img1 = binding.btnBbmMobilSebelum.text.toString()
                    }else if (cekUp==2){
                        binding.btnBbmMobilSetelah.text = file.name.toString().toEditable()
                        img2 = binding.btnBbmMobilSetelah.text.toString()
                    }
                    try {
                        outFile = FileOutputStream(file)
                        if (cekUp==1){
                            bitmap1.compress(Bitmap.CompressFormat.JPEG, 90, outFile)
                        }else if (cekUp==2){
                            bitmap2.compress(Bitmap.CompressFormat.JPEG, 90, outFile)
                        }
                        outFile.flush()
                        outFile.close()
                    } catch (e: FileNotFoundException) {
                        e.printStackTrace()
                    } catch (e: IOException) {
                        e.printStackTrace()
                    } catch (e: Exception) {
                        e.printStackTrace()
                    }
                } catch (e: Exception) {
                    e.printStackTrace()
                }
            }else if (requestCode == 2) {
                val selectedImage = data?.data
                val filePathColumn = arrayOf(MediaStore.Images.Media.DATA)
                val cursor: Cursor? = contentResolver.query(
                    selectedImage!!,
                    filePathColumn, null, null, null
                )
                cursor?.moveToFirst()
                val columnIndex: Int = cursor!!.getColumnIndex(filePathColumn[0])
                val picturePath: String = cursor.getString(columnIndex)
                val imgNama = File(picturePath)
                try {
                    if (cekUp == 1){
                        bitmap1 = MediaStore.Images.Media.getBitmap(contentResolver, selectedImage)
                        bitmap1 = getResizedBitmap(bitmap1, 400)
                        binding.imgBbmMobilSebelum.setImageBitmap(bitmap1)
                        binding.btnBbmMobilSebelum.text = imgNama.name.toString().toEditable()
                        img1 = binding.btnBbmMobilSebelum.text.toString()
                    }else if (cekUp == 2){
                        bitmap2 = MediaStore.Images.Media.getBitmap(contentResolver, selectedImage)
                        bitmap2 = getResizedBitmap(bitmap2, 400)
                        binding.imgBbmMobilSetelah.setImageBitmap(bitmap2)
                        binding.btnBbmMobilSetelah.text = imgNama.name.toString().toEditable()
                        img2 = binding.btnBbmMobilSetelah.text.toString()
                    }

                    var outFile: OutputStream? = null
                    try{
                        outFile = FileOutputStream(imgNama)
                        if (cekUp == 1){
                            bitmap1.compress(Bitmap.CompressFormat.JPEG, 100, outFile)
                        }else if (cekUp == 2){
                            bitmap2.compress(Bitmap.CompressFormat.JPEG, 100, outFile)
                        }
                        outFile.flush()
                        outFile.close()

                    }catch (e: FileNotFoundException) {
                        e.printStackTrace()
                    } catch (e: IOException) {
                        e.printStackTrace()
                    } catch (e: Exception) {
                        e.printStackTrace()
                    }
                } catch (e: IOException) {
                    e.printStackTrace()
                }

            }
        }
    }



    fun BitMapToString(userImage1: Bitmap): String? {
        val baos = ByteArrayOutputStream()
        userImage1.compress(Bitmap.CompressFormat.PNG, 60, baos)
        val b = baos.toByteArray()
        Document_img1 = Base64.encodeToString(b, Base64.DEFAULT)
        return Document_img1
    }
    fun getResizedBitmap(image: Bitmap, maxSize: Int): Bitmap {
        var width = image.width
        var height = image.height
        val bitmapRatio = width.toFloat() / height.toFloat()
        if (bitmapRatio > 1) {
            width = maxSize
            height = (width / bitmapRatio).toInt()
        } else {
            height = maxSize
            width = (height * bitmapRatio).toInt()
        }
        return Bitmap.createScaledBitmap(image, width, height, true)
    }

    fun createTempFile(bitmap: Bitmap):File{
        var file  = File(getExternalFilesDir(Environment.DIRECTORY_PICTURES),
            System.currentTimeMillis().toString()+"_image.PNG")
        var bos = ByteArrayOutputStream()

        bitmap.compress(Bitmap.CompressFormat.PNG,0, bos)
        var bitmapData = bos.toByteArray()

        try {
            var fos =  FileOutputStream(file)
            fos.write(bitmapData)
            fos.flush()
            fos.close()
        } catch (e:IOException) {
            e.printStackTrace()
        }
        return file;

        println(file.toString())
    }

    @NonNull
    fun createFormatString(descriptionString:String): RequestBody {
        return RequestBody.create(
            MultipartBody.FORM, descriptionString);
    }


    fun String.toEditable(): Editable =  Editable.Factory.getInstance().newEditable(this)


    fun addData(id:String, jlhSlrGsSblm:String, jlhSlrGsSdh:String){
        val map = HashMap<String, RequestBody>()
        map.put("id", createFormatString(id))
        map.put("jlh_slr_gs_sblm", createFormatString(jlhSlrGsSblm))
        map.put("jlh_slr_gs_sdh", createFormatString(jlhSlrGsSdh))
        map.put("user_id", createFormatString(sharedPref.getId().toString()))


        var file1: File? = null
        var file2: File? = null
        var gmbr1: MultipartBody.Part? = null
        var gmbr2: MultipartBody.Part? = null


            if(bitmap1 == null && bitmap2 == null ){
                file1 = null
                file2 = null
                gmbr1 = null
                gmbr2 = null
            }else{
                file1 = createTempFile(bitmap1!!)
                val reqFile1 = RequestBody.create(MediaType.parse("image/*"), file1)
                gmbr1 = MultipartBody.Part.createFormData("gbr_gs_sblm", file1.name, reqFile1)

                file2 = createTempFile(bitmap2!!)
                val reqFile2 = RequestBody.create(MediaType.parse("image/*"), file2)
                gmbr2 = MultipartBody.Part.createFormData("gbr_gs_sdh", file2.name, reqFile2)

            }



        RetrofitClient.apiInstance.updatePengambilanSolar(gmbr1, gmbr2, map)
            .enqueue(object : Callback<PengambilanSolarResponse> {
                override fun onResponse(
                    call: Call<PengambilanSolarResponse>,
                    response: Response<PengambilanSolarResponse>
                ) {
                    if (response.isSuccessful){
                        val intent = Intent(this@PengambilanSolarLjtn, MentoringSolar::class.java)
                        Toast.makeText(getApplicationContext(), response.body()?.message, Toast.LENGTH_LONG).show()
                        startActivity(intent)
                        finish()
                        binding.btnSelesai.revertAnimation()
                    }else{
                        Toast.makeText(getApplicationContext(), response.message(),
                            Toast.LENGTH_LONG).show()
                        binding.btnSelesai.revertAnimation()
                    }
                }

                override fun onFailure(call: Call<PengambilanSolarResponse>, t: Throwable) {
                    t.message?.let { Log.d("error Server", it) }
                }

            })

    }

    override fun onSupportNavigateUp():Boolean{
        onBackPressed()
        return true
    }
}