package com.sibatel.solarapp.ui.mobil

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Toast
import androidx.fragment.app.Fragment
import androidx.lifecycle.Observer
import androidx.lifecycle.ViewModelProvider
import com.sibatel.solarapp.adapter.MobilAdapter
import com.sibatel.solarapp.data.model.mobil.Mobil
import com.sibatel.solarapp.data.viewmodel.MobilViewModel
import com.sibatel.solarapp.databinding.FragmentMobilBinding
import com.sibatel.solarapp.utils.ViewModelFactory

class KoordinatorFragment : Fragment() {
    private lateinit var fragmentBinding: FragmentMobilBinding

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        fragmentBinding = FragmentMobilBinding.inflate(inflater, container, false)
        return fragmentBinding.root
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        if (activity!=null){
            val factory = ViewModelFactory.getInstance()
            val viewModelCatalog = ViewModelProvider(
                this, factory
            )[MobilViewModel::class.java]

            val koordinatorMobil = ArrayList<Mobil>()

            showLoading(true)
            viewModelCatalog.getMobil().observe(viewLifecycleOwner, Observer {
               if (it.isEmpty()){
                    Toast.makeText(context, "Data Kosong", Toast.LENGTH_LONG).show()
                }else{
                    it.forEach {
                            if (it.role.equals("koordinator")){
                            koordinatorMobil.add(it)
                        }
                    }

                   if(koordinatorMobil.isEmpty()){
                       Toast.makeText(context, "Data Kosong", Toast.LENGTH_LONG).show()
                   }
                    showDataMobil(koordinatorMobil)
                }
                showLoading(false)
            })
        }
    }

    fun showDataMobil(listItemMovies : ArrayList<Mobil>?){
        fragmentBinding.rvMobil.adapter = MobilAdapter(listItemMovies)
    }

    private fun showLoading(state: Boolean) {
        if (state)
            fragmentBinding.progress.visibility = View.VISIBLE
        else
            fragmentBinding.progress.visibility = View.GONE
    }
}