package com.sibatel.solarapp.ui.user

import android.os.Bundle
import androidx.annotation.StringRes
import androidx.appcompat.app.AppCompatActivity
import com.google.android.material.tabs.TabLayoutMediator
import com.sibatel.solarapp.R
import com.sibatel.solarapp.databinding.ActivityProfilBinding
import com.sibatel.solarapp.utils.SharedPref

class Profil : AppCompatActivity() {
    private lateinit var binding: ActivityProfilBinding
    private lateinit var sharedPref: SharedPref

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ActivityProfilBinding.inflate(layoutInflater)
        setContentView(binding.root)

        supportActionBar?.elevation = 0f
        supportActionBar?.setDisplayHomeAsUpEnabled(true)

        sharedPref = SharedPref(this)

        binding.scdName.text = sharedPref.getNama1()
        binding.userRole.text = sharedPref.getRole1()

        val sectionPagerAdapter = ProfilPagerAdapter(this)
        binding.viewPager.adapter = sectionPagerAdapter

        val tabLayout = binding.tabs



        TabLayoutMediator(tabLayout, binding.viewPager){tab, position ->
            tab.text =  resources.getString(Profil.TAB_TITLES[position])
        }.attach()
    }

    companion object{
        @StringRes
        private val TAB_TITLES = intArrayOf(R.string.SCD, R.string.Koordinator, R.string.CGL, R.string.Koerktif, R.string.Maintenance, R.string.Project)
    }

    override fun onSupportNavigateUp():Boolean{
        onBackPressed()
        return true
    }
}